﻿Imports System.Data
Imports System.Data.OleDb
Public Class frmClientes
    Private cn As New OleDbConnection
    Private da As OleDbDataAdapter
    Private ds As New DataSet
    Private WithEvents bs As New BindingSource
    Private nombreBBDD As String = Application.StartupPath & "\Ejemplo.mdb"

    Private Sub frmClientes_FormClosing(ByVal sender As Object, _
                                        ByVal e As System.Windows.Forms.FormClosingEventArgs) _
                                        Handles Me.FormClosing
        'Impide salir si el IdCliente está vacío
        If txtIdCliente.Text = "" Then
            MessageBox.Show("No puede cerrar la ventana " & _
                            "cuando está añadiendo un cliente." & _
                            ControlChars.CrLf & _
                            "Por favor, cancele la operación antes de salir.", _
                            Me.Text, MessageBoxButtons.OK, _
                            MessageBoxIcon.Information)
            e.Cancel = True
            Exit Sub
        End If
        'Si hay cambios pendientes
        bs.EndEdit()
        If Not ds.GetChanges Is Nothing Then
            If MessageBox.Show("¿Guardar las modificaciones pendientes?", _
                             Me.Text, MessageBoxButtons.YesNo, _
                             MessageBoxIcon.Information, _
                             MessageBoxDefaultButton.Button2) = _
                                   Windows.Forms.DialogResult.Yes Then
                BindingNavigatorUpdate.PerformClick()
            End If
        End If

    End Sub


    Private Sub frmClientes_Load(ByVal sender As System.Object, _
                                 ByVal e As System.EventArgs) Handles MyBase.Load
        ConfigurarAccesoADatos()

        EnlazarControles()
    End Sub

    Private Sub ConfigurarAccesoADatos()
        cn.ConnectionString = "PROVIDER=Microsoft.Jet.Oledb.4.0;Data source=" & nombreBBDD
        cn.Open()
        da = New OleDbDataAdapter("SELECT * FROM Clientes", cn)
        da.Fill(ds, "Clientes")
        cn.Close()

        Dim clave(0) As DataColumn
        clave(0) = New DataColumn
        clave(0) = ds.Tables("Clientes").Columns("IdClientes")
        ds.Tables("Clientes").PrimaryKey = clave

        Dim cb As OleDbCommandBuilder = New OleDbCommandBuilder(da)

    End Sub

    Private Sub EnlazarControles()
        bs.DataSource = ds
        bs.DataMember = "Clientes"

        BindingNavigator1.BindingSource = bs

        txtIdCliente.DataBindings.Add(New Binding("Text", bs, "IdCliente", True))
        txtApellidos.DataBindings.Add(New Binding("Text", bs, "Apellidos", True))
        txtNombre.DataBindings.Add(New Binding("Text", bs, "Nombre", True))
        txtCiudad.DataBindings.Add(New Binding("Text", bs, "Ciudad", True))
        txtCP.DataBindings.Add(New Binding("Text", bs, "CP", True))
        txtProvincia.DataBindings.Add(New Binding("Text", bs, "Provincia", True))

    End Sub

    Private Sub BindingNavigatorUpdate_Click(ByVal sender As System.Object, _
                                             ByVal e As System.EventArgs) Handles BindingNavigatorUpdate.Click
        'EndEdit pasa los cambios al Dataset 
        bs.EndEdit()
        
        'Si hay cambios pendientes en el Dataset
        If Not ds.GetChanges() Is Nothing Then
            Try
                da.Update(ds, "Clientes")
                ds.AcceptChanges()
            Catch ex As Exception
                MessageBox.Show(ex.Message, Me.Text, MessageBoxButtons.OK, _
                               MessageBoxIcon.Information)
                ds.RejectChanges()
            End Try
        End If

    End Sub

    Private Sub BindingNavigatorCancel_Click(ByVal sender As System.Object, _
                                             ByVal e As System.EventArgs) _
                                             Handles BindingNavigatorCancel.Click
        bs.CancelEdit()

    End Sub
End Class
